Rails.application.routes.draw do
	locales = Site.find_by(site_active: true).in_use_locales rescue I18n.available_locales
	scope "(:locale)", locale: Regexp.new(locales.join("|")) do
		namespace :admin do
      		get 'plugin_template_setting' => "plugin_templates#setting"
	    	resources :plugin_templates do
		        collection do
		          get 'toggle_hide' => 'plugin_templates#toggle_hide'
		          get 'analysis'
		          get 'analysis_report'
		          get "download_excel"
		        end
	   	 	end

	    resources :members do
	        collection do
	          scope '(:name-:uid)' do
	            resources :plugin_templates do
	              collection do
	                get 'frontend_setting' => 'plugin_templates#frontend_setting'
	                post 'update_frontend_setting' => 'plugin_templates#update_frontend_setting'
	              end
	            end
	          end
	        end
	    end
  
		resources :plugin_template_relateds
		end
	end
end
